
(define-struct cv (ctx vals default))

;; simplified constructor
(define make-cv/2
  (lambda (ctx val)
    (make-cv ctx 
             (list (cons (ctx) val))
             val)))

;; read a cv
(define (cv-ref cv)
  (let ((key ((cv-ctx cv))))
    (let ((val (assoc key (cv-vals cv))))
      (if val 
          (cdr val) 
          (cv-default cv)))))

;; set a cv
(define (cv-set! cv nval)
  (let ((key ((cv-ctx cv))))
    (let ((val (assoc key (cv-vals cv))))
      (if val 
          (set-cdr! val nval)
          (extend-vals cv key nval)))))

(define (extend-vals cv key val)
   (set-cv-vals! cv (alist-cons key val (cv-vals cv))))

(define alist-cons
  (lambda (key datum alist) (cons (cons key datum) alist)))